clear all;

% Ulozenie vzorky nameranych riadkov (subor riadky.txt) v matici riadky100
load -ascii riadky100.txt;

% Vyber prvych 240 riadkov a ich pretypovanie na uit8
img_all = uint8(riadky100(1:240, :));
clear riadky100;

% Vyber kazdeho 16 px z riadku zlozeneho z 320 px
[pocet_r, pocet_s] = size(img_all);
i = 1;
img = img_all(:,1);
while (i*16) < pocet_s
    img = [img, img_all(:, i * 16)];
    i = i + 1;
end
clear pocet_r pocet_s;

% Inicializacia parametrov neuronovej siete
% n_num - pocet neuronov, i_num - pocet vstupov
n_num = 10; i_num = 20;

% tresh - hodnota prahu neuronov
tresh = 5;

% Inicializacia prepojenia medzi neuronmi, 10 neuronov
ncon = round(rand(n_num, n_num));

% Inicializacia prepojenia vstupov s neuronmi, 10 neuronov s 20 vstupmi
icon = round(rand(n_num, i_num));

% Inicializacia znamienok neuronov, 10 neuronov
nsig = round(rand(1, n_num));
for i = 1 : length(nsig)
    if (nsig(i) == 0) nsig(i) = -1; end
end

% Inicializacia vystupov neuronov a ich potencialov
nout = zeros(1, n_num);
npot = zeros(1, n_num);

% Pocitadlo cyklov, maximalny pocet cyklov
t = 1; tmax = 6000;

% Pocitadlo generovania impulzov odpovedajucich neuronov
spike = zeros(1, n_num);

% Pocitadlo indexu vzorky nasnimanych riadkov
r = 1;

% Vypocet neuronovej siete (6000 cyklov)
while t <= tmax
    % Senzorove vstupy sa aktualizuju po 25 cykloch
    if (mod(t, 25) == 1)
        % Filtrovanie riadku nasnimanych hodnot a ich transformacia do
        % intervalu <0, 1>
        sinp = (round(abs(row_filter(img(r,:)))))/255;
        r = r + 1;
    else
        sinp = zeros(1, i_num);
    end
    
    % Aktualizacia stavu neuronov
    for i = 1 : n_num
        % Kontrola vystupu neuronu z predchadzajuceho cyklu
        if (nout(i) == 1) % Pokojovy stav neuronu
            n_cont(i) = 0;
            i_cont(i) = 0;
        else % Vypocet prirastku neuronov
            n_cont(i) = sum(nout .* ncon(i, :) .* nsig);
            i_cont(i) = sum(sinp .* icon(i, :));
        end

        % Aktualizacia potencialu neuronov
        npot(i) = npot(i) + n_cont(i) + i_cont(i);
        % Kontrola aktualizovaneho potencialu neuronu
        if (npot(i) < 0) npot(i) = 0; end
        
        % Generovanie impulzu
        nois = -1 + 2*rand; % pridanie sumu do potencialu neuronu
        if (npot(i) > (tresh + nois)) % Kontrola prekrocenia prahu
            nout(i) = 1; % Neuron generuje impulz
            spike(i) = spike(i) + 1; % Inkrementovanie pocitadla impulzov
            npot(i) = 0; % Nastavenie potencialu na minimalnu hodnotu
        else
            nout(i) = 0; % Neuron negeneruje impulz
        end
        
        % Nestalost potencialu neuronu
        if (npot(i) - 0.05) >= 0
            npot(i) = npot(i) - 0.05;
        else
            npot(i) = 0;
        end
    end
    t = t + 1; % Inkrementovanie pocitadla cyklov
end